archlinux/aur/urls.py
from django.conf.urls.defaults import *
from aur.models import Package

detail_dict = {
    'queryset': Package.objects.all(),
    'template_object_name': 'pkg',
}

urlpatterns = patterns('aur.views',
    url(r'^$', 'search', name='aur-main'),
    url(r'^search/$', 'search', name='aur-search'),
    url(r'^submit/$', 'submit', name='aur-submit_package'),
    url(r'^package/(?P<object_id>[\w_-]+)/comment/$', 'comment',
        name='aur-comment_on_package'),
    url(r'^package/(?P<object_id>[\w_-]+)/flag_out_of_date/$',
        'flag_out_of_date', name='aur-flag_out_of_date'),
    url(r'^package/(?P<object_id>[\w_-]+)/unflag_out_of_date/$',
        'unflag_out_of_date', name='aur-unflag_out_of_date'),
    url(r'^package/(?P<object_id>[\w_-]+)/notify_of_updates/$',
        'notify_of_updates', name='aur-notify_of_updates'),
    url(r'^package/(?P<object_id>[\w_-]+)/denotify_of_updates/$',
        'denotify_of_updates', name='aur-denotify_of_updates'),
    (r'^api/search/(?P<query>[\w\d_ -]+).(?P<format>(json|xml))$', 'api_search'),
    (r'^api/package/(?P<object_id>[\w_-]+).(?P<format>(json|xml))$', 'api_package_info'),
    (r'^api/package/(?P<object_id>[\w_-]+)/comments.(?P<format>(json|xml))$', 'api_package_comments'),
    url(r'^manage_packages/$', 'manage_packages', name='aur-manage_packages'),
)

# Generic views
# These will probably be removed at a later stage
urlpatterns += patterns('django.views.generic',
    (r'^package/(?P<slug>[\w_-]+)/$', 'list_detail.object_detail',
        dict(detail_dict), 'aur-package_detail'),
)

archlinux/urls.py
from django.conf.urls.defaults import *
from django.contrib import admin
from django.conf import settings

admin.autodiscover()

urlpatterns = patterns('',
    (r'^admin/(.*)', admin.site.root),
    (r'^accounts/', include('registration.urls')),
    (r'^profile/', include('aurprofile.urls')),
    (r'^', include('aur.urls')),
)

if settings.DEBUG == True:
	urlpatterns += patterns('',
		(r'^media/(.*)$', 'django.views.static.serve', {
		    'document_root': settings.MEDIA_ROOT
		})
	)

archlinux/aur/models.py
from django.db import models
from django.db import transaction
from django.contrib.auth.models import User
from django.core.mail import send_mass_mail
from django.db.models import signals, permalink
from django.dispatch import dispatcher
from django.template.loader import render_to_string
from django.utils.encoding import smart_unicode

from tagging.fields import TagField

from datetime import datetime
import os

def _get_package_upload_to(instance, filename):
    """Returns a string, replacing the name placeholder with a packages name

    *instance* should be a :class:`PackageFile` or :class:`Package` instance.

    *filename* should be a a string with a named placeholder where the name
    should be inserted, e.g. ``'%(name)s/sources/PKGBUILD'``.

    .. note::

        This is meant for use by :class:`PackageFile` and :class:`Package` as
        the *upload_to* callable
    """
    if hasattr(instance, 'package'):
        package = instance.package
    else:
        package = instance
    return os.path.join('packages', filename % {'name': package.name})


class Architecture(models.Model):
    name = models.CharField(max_length=10)

    def __unicode__(self):
        return self.name


class Repository(models.Model):
    name = models.CharField(max_length=20)

    def __unicode__(self):
        return self.name

    class Meta:
        verbose_name_plural = 'repositories'


class License(models.Model):
    name = models.CharField(max_length=24)

    def __unicode__(self):
        return self.name


class Group(models.Model):
    name = models.CharField(max_length=10)

    def __unicode__(self):
        return self.name


class Provision(models.Model):
    name = models.CharField(max_length=30)

    def __unicode__(self):
        return self.name


class Package(models.Model):
    name = models.CharField(unique=True, max_length=30, editable=False)
    version = models.CharField(max_length=20)
    release = models.SmallIntegerField()
    description = models.CharField(max_length=180)
    url = models.CharField(max_length=200, null=True, blank=True)
    maintainers = models.ManyToManyField(User)
    repository = models.ForeignKey(Repository)
    tags = TagField()
    slug = models.SlugField(editable=False)
    tarball = models.FileField(upload_to=_get_package_upload_to)
    licenses = models.ManyToManyField(License, null=True, blank=True)
    architectures = models.ManyToManyField(Architecture)
    depends = models.ManyToManyField('self', null=True, blank=True,
            related_name="reverse_depends", symmetrical=False)
    make_depends = models.ManyToManyField('self', null=True, blank=True,
            related_name="reverse_make_depends", symmetrical=False)
    replaces = models.ManyToManyField('self', null=True, blank=True,
            related_name='reverse_replaces', symmetrical=False)
    conflicts = models.ManyToManyField('self', null=True, blank=True,
            related_name="reverse_conflicts", symmetrical=False)
    provides = models.ManyToManyField(Provision, null=True, blank=True)
    deleted = models.BooleanField(default=False)
    outdated = models.BooleanField(default=False)
    added = models.DateTimeField(editable=False, default=datetime.now)
    updated = models.DateTimeField(editable=False)
    groups = models.ManyToManyField(Group, null=True, blank=True)

    def __unicode__(self):
        return u'%s %s' % (self.name, self.version)

    def get_arch(self):
        return ', '.join(map(smart_unicode, self.architectures.all()))
    get_arch.short_description = 'architectures'

    def get_tarball_basename(self):
        """Return the basename of the absolute path to the tarball"""
        return os.path.basename(self.tarball.path)

    def get_absolute_url(self):
        return ('aur-package_detail', [self.slug,])
    get_absolute_url = permalink(get_absolute_url)

    def save(self):
        self.updated = datetime.now()
        if not self.slug:
            import re
            slug = re.sub('[^\w\s-]', '', self.name).strip().lower()
            slug = re.sub('[-\s]+', '-', slug)
            self.slug = slug
        super(Package, self).save()

    class Meta:
        ordering = ('-updated',)
        get_latest_by = 'updated'


class PackageFile(models.Model):
    package = models.ForeignKey(Package)
    # filename for local sources and url for external
    filename = models.FileField(upload_to=_get_package_upload_to, null=True, blank=True)
    url = models.URLField(null=True, blank=True)

    def get_absolute_url(self):
        if self.filename:
            return self.filename.url
        else:
            return self.url

    def get_filename(self):
        if self.filename:
            return os.path.basename(self.filename.path)
        else:
            return self.url

    def __unicode__(self):
        return self.filename

class PackageHash(models.Model):
    # sha512 hashes are 128 characters
    hash = models.CharField(max_length=128, primary_key=True)
    type = models.CharField(max_length=12)
    file = models.ForeignKey(PackageFile)

    def __unicode__(self):
        return self.hash

    class Meta:
        verbose_name_plural = 'package hashes'


class Comment(models.Model):
    package = models.ForeignKey(Package)
    parent = models.ForeignKey('self', null=True, blank=True)
    user = models.ForeignKey(User)
    message = models.TextField()
    added = models.DateTimeField(editable=False, default=datetime.now)
    ip = models.IPAddressField()
    hidden = models.BooleanField(default=False)

    def __unicode__(self):
        return self.message


class PackageNotification(models.Model):
    user = models.ForeignKey(User)
    package = models.ForeignKey(Package)

    def __unicode__(self):
        return u"%s's subscription to %s updates" % (self.user.username,
                self.package.name)


# Should this be here?
def email_package_updates(sender, instance, signal, *args, **kwargs):
    from django.conf import settings
    """Send notification to users of modification to a Package"""
    subject = "Archlinux AUR: %s updated" % instance.name
    mail_list = []
    notifications = PackageNotification.objects.filter(package=instance)
    for notification in notifications:
        if not notification.user.email:
            continue
        message = render_to_string('aur/email_notification.txt', {
            'package': instance,
            'user': notification.user,
        })
        mail_list.append((subject, message, settings.DEFAULT_FROM_EMAIL,
            (notification.user.email,)))
    return send_mass_mail(mail_list)


def remove_packagefile_filename(sender, instance, signal, *args, **kwargs):
    """Remove PackageFile's file"""
    if instance.filename:
        instance.filename.delete()

def remove_package_tarball(sender, instance, signal, *args, **kwargs):
    """Remove Package's tarball"""
    instance.tarball.delete()

# Send notifications of updates to users on saves and deltion of packages
signals.post_save.connect(email_package_updates, sender=Package)
signals.post_delete.connect(email_package_updates, sender=Package)
# Remove files when packages get deleted
# Django doesn't call each instance's delete() on cascade, but it does send
# pre_delete signals
signals.pre_delete.connect(remove_packagefile_filename, sender=PackageFile)
signals.pre_delete.connect(remove_package_tarball, sender=Package)

archlinux/templates/aur/error.html
{% extends "base.html" %}
{% load i18n %}
{% block extra_title %} - {% trans "Error" %} {{ heading }}{% endblock %}
{% block content %}
<div class="greybox">
    <h2>{{ heading }}</h2>
    {{ error|linebreaks }}
</div>
{% endblock %}

archlinux/templates/aur/package_detail.html
{% extends "base.html" %}
{% load i18n %}
{% load aur_tags %}
{% load tagging_tags %}
{% block extra_title %} - {{ pkg.name }} {{ pkg.version }}-{{ pkg.release}}{% endblock %}
{% block content %}
<div class="box">
    <h2 class="title">{{ pkg.name }} {{ pkg.version }}-{{ pkg.release }}</h2>
    <div style="float:right" class="listing">
        <ul class="small">
            <li>
                {% if user|has_update_notification:pkg %}
                <a href="{% url aur-denotify_of_updates object_id=pkg.name %}">{% trans "Stop notifying me of updates" %}</a>
                {% else %}
                <a href="{% url aur-notify_of_updates object_id=pkg.name %}">{% trans "Notify me of updates" %}</a></li>
                {% endif %}
            <li>
            {% if pkg.outdated %}
                <a href="{% url aur-unflag_out_of_date object_id=pkg.name %}">{% trans "Unflag Package Out-of-Date" %}</a>
            {% else %}
            <a href="{% url aur-flag_out_of_date object_id=pkg.name %}">{% trans "Flag Package Out-of-Date" %}</a> <a target="_blank" href="http://www.archlinux.org/packages/flaghelp/">(?)</a>
            {% endif %}
            </li>
        </ul>
    </div>
    <table class="listing">
        <tr>
            <th>{% trans "Repository" %}:</th>
            <td>{{ pkg.repository.name }}</td>
        </tr><tr>
        <th>{% trans "Tags" %}:</th>
            {% tags_for_object pkg as pkg_tags %}
            <td>{{ pkg_tags|join:", " }}</td>
        </tr><tr>
            <th>{% trans "Description" %}:</th>
            <td>{{ pkg.description }}</td>
        </tr><tr>
            <th>{% trans "Architecture" %}:</th>
            <td>{{ pkg.get_arch }}</td>
            </tr>{% if pkg.url %}<tr>
            <th>{% trans "URL" %}:</th>
            <td><a href="{{ pkg.url }}">{{ pkg.url }}</a></td>
            </tr>{% endif %}<tr>
            <th>{% trans "License" %}:</th>
            <td>{{ pkg.licenses.all|join:", " }}</td>
        </tr><tr>
            <th>{% trans "Maintainer" %}:</th>
            <td>{{ pkg.maintainers.all|join:", " }}</td>
        </tr><tr>
            <th>{% trans "Last Updated" %}:</th>
            <td>{{ pkg.updated|date:"Y-m-d H:i:s" }}</td>
        </tr><tr>
            <th>{% trans "Download" %}</th>
            <td><a href="{{ pkg.tarball.url }}">{{ pkg.get_tarball_basename }}</a></td>
        </tr>
    </table>
    <br />
    <table width="100%">
        <tr>
            <td valign="top">
                <div class="listing">
                    <h4>{% trans "Dependencies" %}:</h4>
                    <ul style="font-size:small;list-style:none">
                    {% ifnotequal pkg.depends.all.count 0 %}
                        {% for dep in pkg.depends.all %}
                        <li><a href="{{ dep.get_absolute_url }}">{{ dep.name }}</a></li>
                        {% endfor %}
                    {% else %}
                        <li>{% trans "None" %}</li>
                    {% endifnotequal %}</ul>
                </div>
            </td><td valign="top">
                <div class="listing">
                    <h4>{% trans "Required By" %}:</h4>
                    <ul style="font-size:small;list-style:none">
                    {% ifnotequal pkg.reverse_depends.all.count 0 %}
                        {% for dep in pkg.reverse_depends.all %}
                        <li><a href="{{ dep.get_absolute_url }}">{{ dep.name }}</a></li>
                        {% endfor %}
                    {% else %}
                        <li>{% trans "None" %}</li>
                    {% endifnotequal %}</ul>
                </div>
            </td><td valign="top">
                <div class="listing">
                    <h4>{% trans "Sources" %}:</h4>
                    <ul style="font-size:small;list-style:none">
                    {% ifnotequal pkg.packagefile_set.all.count 0 %}
                        {% for source in pkg.packagefile_set.all %}
                        <li><a href="{{ source.get_absolute_url }}">{{ source.get_filename }}</a></li>
                        {% endfor %}
                    {% else %}
                        <li>{% trans "None" %}</li>
                    {% endifnotequal %}</ul>
                </div>
            </td>
        </tr>
    </table>
</div>
{% ifnotequal pkg.comment_set.count 0 %}
<br />
<h2 class="title">{% trans "Comments" %}</h2>
<div class="greybox">
    {% for comment in pkg.comment_set.all %}
    <span style="float:right; font-size:x-small">{{ comment.added|date }}
        {{ comment.added|time }}</span>
    <h4 class="news"><a href="#">{{ comment.user }}</a></h4>
    <p class="news">{{ comment.message }}</p>
    <br />
    <div style="text-align:right">
    <form action="{% url aur.views.comment object_id=pkg.name %}" method="post">
            <input type="hidden" name="reply_to" value="{{ comment.id }}" />
            <input type="submit" value="{% trans "Reply" %}" />
        </form>
    </div>
    {% if not forloop.last %}<br />{% endif %}
    {% endfor %}
</div>
{% endifnotequal %}
<br />
<h2 class="title">{% trans "Post comment" %}</h2>
<div class="greybox" style="text-align:right">
    <form action="{% url aur.views.comment object_id=pkg.name %}" method="post">
        <textarea name="message" style="width:100%;" rows="10"></textarea><br />
        <input type="submit" value="{% trans "Reply" %}" />
    </form>
</div>
{% endblock %}

archlinux/templates/aur/search.html
{% extends "base.html" %}
{% load i18n %}
{% load aur_tags %}
{% block search %}{% endblock %}
{% block content %}
<div class="greybox">
    <h4 style="text-align: right">{% trans "Search Criteria" %}</h4>
    <hr />
    <form method="get" action="/search/">
        <table width="100%">
            <tr>
                {% for field in form %}
                <th style="text-align: left"><span class="smalltext">{{ field.label_tag }}</span></th>
                {% endfor %}
                <th>&nbsp;</th>
            </tr>
            <tr>
                {% for field in form %}
                <td>{{ field }}{% if field.help_text %}<br />{{ field.help_text }}{% endif %}</td>
                {% endfor %}
                <td><input type="submit" value="Search" /></td>
            </tr>
            {% if is_bound and not form.is_valid %}
            <tr>
                {% for field in form %}
                <td class="error smalltext">{% if field.errors %}
                    {{ field.errors }}{% else %}&nbsp;
                {% endif %}</td>
                {% endfor %}
                <td>&nbsp;</td>
            </tr>
            {% endif %}
        </table>
    </form>
</div>
<br />

<div class="greybox">
    {% if is_moderator %}
    <form action="{% url aur-manage_packages %}" method="post">
    {% endif %}
    <table class="results" width="100%">
        <tr>
            {% if not request.META.QUERY_STRING %}
                <th><a href="{% url aur-search %}?sortby=repository&order=desc">{% trans "Repository" %}</a></th>
                <th><a href="{% url aur-search %}?sortby=name&order=desc">{% trans "Name" %}</a></th>
                <th><a href="{% url aur-search %}?sortby=description&order=desc">{% trans "Description" %}</a></th>
                <th>{% trans "Maintainer" %}</a></th>
                <th style="width: 9em"><a href="{% url aur-search %}?sortby=updated&order=desc">{% trans "Last Updated" %}</a></th>
                {% if is_moderator %}
                <th>&nbsp;</th>
                {% endif %}
            {% else %}
                {% ifequal request.GET.order "asc" %}
                    <th><a href="{% url aur-search %}?{{ request.META.QUERY_STRING|merge_query_string:"sortby=repository&order=desc"}}">{% trans "Repository" %}</a></th>
                    <th><a href="{% url aur-search %}?{{ request.META.QUERY_STRING|merge_query_string:"sortby=name&order=desc"}}">{% trans "Name" %}</a></th>
                    <th><a href="{% url aur-search %}?{{ request.META.QUERY_STRING|merge_query_string:"sortby=description&order=desc"}}">{% trans "Description" %}</a></th>
                    <th>{% trans "Maintainer" %}</th>
                    <th style="width: 9em"><a href="{% url aur-search %}?{{ request.META.QUERY_STRING|merge_query_string:"sortby=updated&order=desc"}}">{% trans "Last Updated" %}</a></th>
                {% else %}
                    <th><a href="{% url aur-search %}?{{ request.META.QUERY_STRING|merge_query_string:"sortby=repository&order=asc"}}">{% trans "Repository" %}</a></th>
                    <th><a href="{% url aur-search %}?{{ request.META.QUERY_STRING|merge_query_string:"sortby=name&order=asc"}}">{% trans "Name" %}</a></th>
                    <th><a href="{% url aur-search %}?{{ request.META.QUERY_STRING|merge_query_string:"sortby=description&order=asc"}}">{% trans "Description" %}</a></th>
                    <th>{% trans "Maintainer" %}</th>
                    <th style="width: 9em"><a href="{% url aur-search %}?{{ request.META.QUERY_STRING|merge_query_string:"sortby=updated&order=asc"}}">{% trans "Last Updated" %}</a></th>
                {% endifequal %}
                {% if is_moderator %}
                <th>&nbsp;</th>
                {% endif %}
            {% endif %}
        </tr>
        {% ifnotequal packages.count 0 %}
        {% for package in packages %}
        <tr class="{% cycle 'pkgr1' 'pkgr2' %}">
            <td>{{ package.repository }}</td>
            <td><a{% if package.outdated %} class="error"{% endif %} href="{{ package.get_absolute_url }}">{{ package.name }} {{ package.version }}-{{ package.release }}</a></td>
            <td>{{ package.description }}</td>
            <td>{{ package.maintainers.all|join:", " }}</td>
            <td>{{ package.updated|date:"Y-m-d H:i:s" }}</td>
            {% if is_moderator %}
            <td><input type="checkbox" name="packages" value="{{ package.name }}" /></td>
            {% endif %}
        </tr>
        {% endfor %}
        {% else %}
        {% if form.is_bound %}
        <tr>
            <td colspan="6" style="text-align: center"><p>{% trans "There were no results for your query" %}</p></td>
        </tr>
        {% else %}
        <tr>
            <td colspan="6" style="text-align: center"><p>{% trans "There are currently no packages available" %}</p></td>
        </tr>
        {% endif %}
        {% endifnotequal %}
    </table>
    {% if is_moderator %}
    <br />
    <div style="text-align: right">
        With selected packages:
        <select name="action">
            <option value="disown">disown</option>
            <option value="adopt">adopt</option>
            <option value="flag-ood">flag out of date</option>
            <option value="unflag-ood">unflag out of date</option>
            <option value="delete">delete</option>
        </select>
        <input type="submit" value="{% trans "Apply" %}" />
    </div>
    {% endif %}
    </form>{% if page.has_pagination %}
    <br />
    {% if page.has_previous %}<span style="float: left"><a href="?page={{ page.previous_page_number }}">&lt;&lt;&lt; {% trans "Previous" %}</a></span>{% endif %}
    {% if page.has_next %}<span style="float: right"><a href="?page={{ page.next_page_number }}">{% trans "Next" %} &gt;&gt;&gt;</a></span>{% endif %}
    {%endif %}
</div>
{% endblock %}

archlinux/templates/aur/submit.html
{% extends "base.html" %}
{% load i18n %}
{% block extra_title %} - {% trans "Submit package" %}{% endblock %}
{% block content %}
{% if errors or warnings %}
<div class="greybox errors">
    <p style="padding:0px;">{% trans "Your package failed to validate. Here's why" %}:</p>
    <ul>
        {% for error in errors %}
        <li class="error">{% trans "Error" %}: {{ error }}</li>
        {% endfor %}
        {% for warning in warnings %}
        <li class="error" style="color:#f57900">{% trans "Warning" %}: {{ warning }}</li>
        {% endfor %}
    </ul>
</div>
<br />
{% endif %}
<div class="greybox" style="max-width: 800px; margin: auto;">
    <h3>Submit Package</h3>
    <p>Please read the <a href=http://wiki.archlinux.org/index.php/Arch_Packaging_Standards#Submitting_Packages_to_the_AUR">guidelines for submitting packages</a> and run namcap on the PKGBUILD and built package before submitting.</p>
    {% if not form.is_valid and form.is_bound %}
    <h4>Errors</h4>
    {{ form.errors }}
    {% endif %}
    <form action="." method="post"{% if form.is_multipart %} enctype="multipart/form-data"{% endif %}>
        <div style="text-align:center">
            {% for field in form %}{{ field }} {% endfor %}
            <input type="submit" value="{% trans "Upload" %}" />
        </div>
    </form>
    <br />
</div>
{% endblock %}